#include <iostream>
#include <string.h>

using namespace std;

void le_String(char v[][100], int n)
{
    cout << "Digite o vetor: "<<endl;
    for(int i = 0; i < n; i++)
    {
        cin.getline(v[i], 100);

    }
}

void inserttionSort(char v[][100], int n)
{
    int i, j; char x[100];
    for(i = 1; i < n; i++)
    {
        strcpy(x, v[i]); //x=v[i];
        j = i-1;
        while(j >= 0 && strcmp(v[j], x) > 0) //v[j]>x)
        {
           strcpy(v[j+1], v[j]); //v[j+1] = v[j];
           j--;
        }
        strcpy(v[j+1], x); //v[j+1]=x;
    }
}

void selectionSort(char v[][100], int n)
{
    int i, j, menor; char aux[100];

    for(i = 0; i < n-1; i++)
    {
        menor = i;
        for(j = i+1; j < n; j++) //fica nesse for para achar o menor elemento do vetor e troca com a 1 posicao; depois com a 2posicao
        {
            if(strcmp(v[j], v[menor]) < 0) //(v[j]<v[menor])  => v[j] vem antes de v[j+1]
            {
                menor = j;
            }
        }
        strcpy(aux, v[i]); strcpy(v[i], v[menor]); strcpy(v[menor], aux); //aux =v[i]; v[i]=v[menor]; v[menor]=aux;
    }
}

void bubbleSort(char v[][100], int n)
{
    int i, j; char aux[100];
    for(i = n-1; i > 0; i--)
    {
            for(j = 0; j < i; j++)
            {
                if( strcmp(v[j], v[j+1]) > 0) //if(v[j]>v[j+1]) =>  v[j] eh depois de v[j+1]
                {
                    strcpy(aux,v[j]); strcpy(v[j], v[j+1]); strcpy(v[j+1], aux); //aux=v[j]; v[j]=v[j+1]; v[j+1]=aux;
                }
            }
    }
}

void imprime_V(char v[][100], int n)
{
    for(int i = 0; i < n; i++)
    {
        cout << v[i] << endl;
    }
}

int main()
{
    char op;
    int n;
    char v[100][100];
    char lixo[1];

    cout << "Digite a qta de strings (qta de linhas): " << endl;
    cin >> n;
    cin.getline(lixo, 1);//consumir o enter da leitura de n, cin no l o enter
    le_String(v, n);
    do
    {
      cout << endl;
      cout << "Escolha uma funcao para ordenar strings:" << endl
           << "    i-insertion sort, " << endl
           << "    s-selection sort, " << endl
           << "    b-bubble sort" << endl
           << "    informe sua escolha: ";
      cin >> op;
      switch (op)
      {
          case 'i': inserttionSort(v, n);
                    break;
          case 's': selectionSort(v, n);
                    break;
          case 'b': bubbleSort(v, n);
                    break;
          default: cout << "operacao invalida" << endl;
      }
    }
    while(op != 'i' && op != 's' && op != 'b');
    cout << endl;
    cout << "* vetro ordenado *" << endl;
    imprime_V(v, n);
    cout << endl;

    return 0;
}
